#ifndef FILE_HPP
#define FILE_HPP

#include <stdint.h>

namespace t3d{

enum class FileOpenMode{
    Read,
    Write
};

enum class OffsetCursor{
    Set,
    End,
    Cur
};

class File{
public:
    virtual int read(void *data, uint64_t size) = 0;
    virtual int write(void *data, uint64_t size) = 0;
    virtual void seek(uint64_t offset, OffsetCursor offsetCursor) = 0;
    virtual uint64_t tell() const = 0;
    virtual void close() = 0;
    virtual bool isEof() const = 0;
    virtual ~File() {}
};

}

#endif
